<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" >
    <template #footer>
        <a-button v-show="!isDetail && isUpdate" key="back" @click="handleCancel">取消</a-button>
        <a-button v-show="!isDetail && isUpdate" key="continue" @click="handleContinueSubmit">继续添加</a-button>
        <a-button v-show="!isDetail" key="submit" type="primary" @click="handleSubmit">确定</a-button>
      </template>  
    <BasicForm  @register="registerForm"/>
  </BasicModal>
</template>

<script lang="ts" setup>
import { computed, ref, unref } from 'vue';
import { editProjectCheck } from '../../StProjectConfig.api';
import { formSchema } from './StCaMainCheck.data';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BasicModal, useModalInner } from '/@/components/Modal';
    // Emits声明
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);   
    const actinfo = ref({
        projectCreId:null,
        caNo: null,
    })
    const isDetail = ref(false);
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        isDetail.value = !data?.showFooter;
        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
            actinfo.value.projectCreId = data.record.projectCreId
            actinfo.value.caNo = data.record.caNo
            // 改变pFlag状态
        }
        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    const title = computed(() => (!unref(isUpdate) ? '填写检查方法' : (unref(isDetail)?'查看检查方法':'配置检查方法')));
    
    function handleCancel() {
        closeModal()
    }
    async function handleContinueSubmit(v){
        try {
            let values = await validate();
            setModalProps({confirmLoading: true});
            //提交表单
            await editProjectCheck(values);
            await resetFields();
            setFieldsValue({
                ...actinfo.value,
            });
            // //关闭弹窗
            // closeModal();
            //刷新列表
            emit('success');
        } finally {
            setModalProps({confirmLoading: false});
        }
    }
    //表单提交事件
    async function handleSubmit(v) {
        try {
            let values = await validate();
            setModalProps({confirmLoading: true});
            //提交表单
            await editProjectCheck(values);
            //关闭弹窗
            closeModal();
            //刷新列表
            emit('success');
        } finally {
            setModalProps({confirmLoading: false});
        }
    }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>